searchData={"items":[{"type":"module","title":"Netatmox","doc":"Documentation for `Netatmox`.","ref":"Netatmox.html"},{"type":"function","title":"Netatmox.refresh_token/3","doc":"Refresh both, access and refresh token, with a still valid refresh token.\nTokens are valid for 3h.","ref":"Netatmox.html#refresh_token/3"},{"type":"function","title":"Netatmox.station_data/1","doc":"Retrieve weater data from a Netatmo station with an associated access token","ref":"Netatmox.html#station_data/1"},{"type":"module","title":"Netatmox.Api","doc":"Get an initial access_token with https://github.com/tvecera/netatmo-auth-cli or from netatmo dev portal after login","ref":"Netatmox.Api.html"},{"type":"function","title":"Netatmox.Api.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"Netatmox.Api.html#delete/3"},{"type":"function","title":"Netatmox.Api.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Netatmox.Api.html#delete!/3"},{"type":"function","title":"Netatmox.Api.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"Netatmox.Api.html#get/3"},{"type":"function","title":"Netatmox.Api.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Netatmox.Api.html#get!/3"},{"type":"function","title":"Netatmox.Api.get_auth_url/1","doc":"","ref":"Netatmox.Api.html#get_auth_url/1"},{"type":"function","title":"Netatmox.Api.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"Netatmox.Api.html#head/3"},{"type":"function","title":"Netatmox.Api.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Netatmox.Api.html#head!/3"},{"type":"function","title":"Netatmox.Api.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"Netatmox.Api.html#options/3"},{"type":"function","title":"Netatmox.Api.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Netatmox.Api.html#options!/3"},{"type":"function","title":"Netatmox.Api.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Netatmox.Api.html#patch/4"},{"type":"function","title":"Netatmox.Api.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Netatmox.Api.html#patch!/4"},{"type":"function","title":"Netatmox.Api.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Netatmox.Api.html#post/4"},{"type":"function","title":"Netatmox.Api.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Netatmox.Api.html#post!/4"},{"type":"function","title":"Netatmox.Api.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Netatmox.Api.html#put/4"},{"type":"function","title":"Netatmox.Api.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Netatmox.Api.html#put!/4"},{"type":"function","title":"Netatmox.Api.refresh_token/3","doc":"","ref":"Netatmox.Api.html#refresh_token/3"},{"type":"function","title":"Netatmox.Api.request/2","doc":"Perform a request.","ref":"Netatmox.Api.html#request/2"},{"type":"function","title":"Options - Netatmox.Api.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"Netatmox.Api.html#request/2-options"},{"type":"function","title":"Examples - Netatmox.Api.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"Netatmox.Api.html#request/2-examples"},{"type":"function","title":"Netatmox.Api.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"Netatmox.Api.html#request!/2"},{"type":"function","title":"Netatmox.Api.retrieve_token/3","doc":"","ref":"Netatmox.Api.html#retrieve_token/3"},{"type":"function","title":"Netatmox.Api.station_data/1","doc":"","ref":"Netatmox.Api.html#station_data/1"},{"type":"function","title":"Netatmox.Api.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"Netatmox.Api.html#trace/3"},{"type":"function","title":"Netatmox.Api.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Netatmox.Api.html#trace!/3"},{"type":"type","title":"Netatmox.Api.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"Netatmox.Api.html#t:option/0"},{"type":"module","title":"Netatmox.Endpoints","doc":"","ref":"Netatmox.Endpoints.html"},{"type":"function","title":"Netatmox.Endpoints.auth/0","doc":"","ref":"Netatmox.Endpoints.html#auth/0"},{"type":"function","title":"Netatmox.Endpoints.home_status/0","doc":"","ref":"Netatmox.Endpoints.html#home_status/0"},{"type":"function","title":"Netatmox.Endpoints.host/0","doc":"","ref":"Netatmox.Endpoints.html#host/0"},{"type":"function","title":"Netatmox.Endpoints.measure/0","doc":"","ref":"Netatmox.Endpoints.html#measure/0"},{"type":"function","title":"Netatmox.Endpoints.station_data/0","doc":"","ref":"Netatmox.Endpoints.html#station_data/0"},{"type":"function","title":"Netatmox.Endpoints.token/0","doc":"","ref":"Netatmox.Endpoints.html#token/0"},{"type":"module","title":"Netatmox.Scopes","doc":"","ref":"Netatmox.Scopes.html"},{"type":"function","title":"Netatmox.Scopes.access_camera/0","doc":"","ref":"Netatmox.Scopes.html#access_camera/0"},{"type":"function","title":"Netatmox.Scopes.access_presence/0","doc":"","ref":"Netatmox.Scopes.html#access_presence/0"},{"type":"function","title":"Netatmox.Scopes.read_camera/0","doc":"","ref":"Netatmox.Scopes.html#read_camera/0"},{"type":"function","title":"Netatmox.Scopes.read_homecoach/0","doc":"","ref":"Netatmox.Scopes.html#read_homecoach/0"},{"type":"function","title":"Netatmox.Scopes.read_presence/0","doc":"","ref":"Netatmox.Scopes.html#read_presence/0"},{"type":"function","title":"Netatmox.Scopes.read_smokedetector/0","doc":"","ref":"Netatmox.Scopes.html#read_smokedetector/0"},{"type":"function","title":"Netatmox.Scopes.read_station/0","doc":"","ref":"Netatmox.Scopes.html#read_station/0"},{"type":"function","title":"Netatmox.Scopes.read_thermostat/0","doc":"","ref":"Netatmox.Scopes.html#read_thermostat/0"},{"type":"function","title":"Netatmox.Scopes.write_camera/0","doc":"","ref":"Netatmox.Scopes.html#write_camera/0"},{"type":"function","title":"Netatmox.Scopes.write_thermostat/0","doc":"","ref":"Netatmox.Scopes.html#write_thermostat/0"},{"type":"extras","title":"Netatmox","doc":"# Netatmox\n\nA simple wrapper around the Netatmo Weather API.\nCurrently just two functions are supported. One to retrieve the station data and another to update the tokens.","ref":"readme.html"},{"type":"extras","title":"Tokens - Netatmox","doc":"You need an access token with the scope `read_station` to get the data from your weather station. The token is right now only 3h valid and needs to be refreshed with an refresh token. You can either use something like [Netatmo-Auth-Cli](https://github.com/tvecera/netatmo-auth-cli) to do the inital OAuth2 flow to retrieve the tokens or you can generate an access and refresh from the app page in the Netatmo dev portal.\n\nMake sure to save both access and refresh token after every refresh as both will invalidate after 3h and you need the refreh token to do so.","ref":"readme.html#tokens"},{"type":"extras","title":"Usage - Netatmox","doc":"Get station data:\n```elixir\nNetatmox.station_data(\"18e982cb723c36c7b...\")\n{:ok,\n %{\n   \"body\" => %{\n     \"devices\" => [\n       %{\n         \"co2_calibrating\" => false,\n         \"dashboard_data\" => %{\n           \"AbsolutePressure\" => 985.3,\n           \"CO2\" => 1449,\n           \"Humidity\" => 65,\n           \"Noise\" => 35,\n           \"Pressure\" => 1008.1,\n           \"Temperature\" => 21.3,\n           \"date_max_temp\" => 1702422085,\n           \"date_min_temp\" => 1702429337,\n           \"max_temp\" => 21.4,\n           \"min_temp\" => 20.9,\n           \"pressure_trend\" => \"up\",\n           \"temp_trend\" => \"stable\",\n         }\n         # ...\n       }\n     ]\n   }\n }\n}\n```\n\nRefresh tokens:\n```elixir\nNetatmox.refresh_token(client_id, client_secret, refresh_token)\n{:ok,\n %{\n   \"access_token\" => \"18e982cb723c36c7b...\",\n   \"expire_in\" => 10800,\n   \"expires_in\" => 10800,\n   \"refresh_token\" => \"18e982cb723c36c7b...\",\n   \"scope\" => [\"read_station\"]\n }}\n```","ref":"readme.html#usage"},{"type":"extras","title":"Installation - Netatmox","doc":"The package can be installed by adding `netatmox` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:netatmox, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"}],"content_type":"text/markdown"}